<?php

namespace Drupal\entity_extender;

use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;
use Drupal\Core\Plugin\DefaultPluginManager as DefaultPluginManagerBase;

/**
 * The base class for plugin managers.
 *
 * @ingroup plugin_api
 */
class DefaultPluginManager extends DefaultPluginManagerBase {

  /**
   * The class or interface that all plugins must inherit/implement.
   */
  protected const PLUGINS_BASE_CLASS = '';

  /**
   * The annotation for defining the plugin.
   */
  protected const PLUGINS_ANNOTATION_CLASS = '';

  /**
   * {@inheritdoc}
   */
  public function __construct(\Traversable $namespaces, CacheBackendInterface $cache_backend, ModuleHandlerInterface $module_handler) {
    $annotation = explode('\\', static::PLUGINS_ANNOTATION_CLASS);
    // The subdirectory in "src" where the plugins should be looked up.
    $subdir = 'Plugin/' . end($annotation);

    parent::__construct($subdir, $namespaces, $module_handler, static::PLUGINS_BASE_CLASS, static::PLUGINS_ANNOTATION_CLASS);

    $this->setCacheBackend($cache_backend, $subdir);
  }

}
