<?php

namespace Drupal\entity_extender\Entity\Handler\Entity;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\Core\Entity\Display\EntityViewDisplayInterface;
use Drupal\Core\Entity\EntityInterface;

/**
 * The extended view builder for nodes.
 *
 * @see entity_extender_entity_type_alter()
 */
trait EntityViewHandlerTrait {

  use EntityHandlerEntityExtenderManagerInjector;

  /**
   * {@inheritdoc}
   */
  protected function alterBuild(array &$build, EntityInterface $entity, EntityViewDisplayInterface $display, $view_mode): void {
    \assert($entity instanceof ContentEntityInterface);

    if ($extender = $this->getExtender($display->getEntityTypeId(), $display->getTargetBundle(), $entity)) {
      $extender->alterRenderableData($build, $display, $view_mode);
    }
  }

}
