<?php

namespace Drupal\entity_extender\Plugin\EntityExtender\Node;

/**
 * The interface to implement by a "node:CONTENT_TYPE" extender plugin.
 *
 * The purpose of this interface is to allow an extender to react
 * on node save.
 *
 * @see \Drupal\entity_extender\Entity\Handler\Node\NodeStorageHandler::doPreSave()
 */
interface NodeSaveInterface {

  /**
   * Reacts on the attempt to save a node.
   *
   * @throws \Exception
   *   When a save should be prevented.
   */
  public function preSave(): void;

  /**
   * Triggers after a node was saved.
   */
  public function postSave(): void;

}
