<?php

namespace Drupal\entity_extender\Plugin\EntityExtender\User;

/**
 * The interface to implement by a "user:user" extender plugin.
 *
 * The purpose of this interface is to allow an extender to react
 * on user save.
 *
 * @see \Drupal\entity_extender\Entity\Handler\User\UserStorageHandler::doPreSave()
 * @see \Drupal\entity_extender\Entity\Handler\User\UserStorageHandler::doPostSave()
 */
interface UserSaveInterface {

  /**
   * Reacts on the attempt to save a user.
   *
   * @throws \Exception
   *   When a save should be prevented.
   */
  public function preSave(): void;

  /**
   * Triggers after a user was saved.
   */
  public function postSave(): void;

}
